<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { Faq, CropInfinityHero, NextStep } from '../components/common/index';
import { SalesForm } from '../components/sales/index.vue';
import { getPageMetadata } from '~/common/meta';

export default Vue.extend({
  components: {
    Faq,
    SalesForm,
    CropInfinityHero,
    NextStep,
  },
  async asyncData({ $content, error, i18n }: any) {
    try {
      const locale = i18n.locale === i18n.defaultLocale ? '' : i18n.locale;
      const sales = await $content(locale, 'sales').fetch();

      return { sales };
    } catch (e) {
      error({ statusCode: 404 });
      return {};
    }
  },
  head(): MetaInfo {
    const metaInfo = getPageMetadata(
      (this as any).sales,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
    const isInternationalization =
      this.$i18n.locale !== this.$i18n.defaultLocale;

    if (isInternationalization) {
      metaInfo.meta.push({
        hid: 'salesRobots',
        name: 'robots',
        content: 'noindex,nofollow',
      });
    }

    return metaInfo;
  },
});
</script>

<template>
  <section>
    <component
      :is="component.name"
      v-for="(component, index) in sales.components"
      :key="component.name + `-${index}`"
      :data="component.data"
    />
    <section class="slp-bg-surface-800">
      <faq :data="sales.faq" />
    </section>
    <SlpContainer variant="gradient">
      <NextStep :variant="2" :custom-body="sales.next_step" />
    </SlpContainer>
  </section>
</template>
